Program A64;

{ C64 Assembler (c) 1998, Paul TOTH <tothpaul@multimania.com>

 http://www.multimania.com/tothpaul

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}
(*
  .BASIC ;--- ORG $0801
   10 SYS @START
  .DATA  ;--- SOME DATA
   MSG DB "Hello World !",13,0
  .CODE  ;--- START ASM
  @START:
   LDA #<MSG
   LDY #>MSG
   JSR $AB1E ;- PRINT STRING AY
   RTS   ;--- BACK TO BASIC
  END

 todo :

  - support of pseudo codes for BASIC, like {clear}{home}{up} ...
  - more sections like CONST, MACRO, DATA?
  - support of INCLUDE
  - support of arithmetics expression : LDA 2*5; STA $0400+40*4+12

  - a 6510 Pascal compiler :)

*)

Uses
 Except,PRG;

var
 src:string;
 dst:string;
 pgm:TPRG;
 ECompile:TException;

begin
 writeln(Version);
 if paramcount=0 then exit;

 src:=paramstr(1);

 if src='/?' then begin
  writeln('A64 source[.A64]');
  writeln('Create a source.prg C64 program');
  writeln('A64 Syntaxe :');
  writeln('.BASIC ; Start of BASIC Program');
  writeln('10 SYS @Start');
  writeln('.DATA ; Start of data');
  writeln(' MSG DB "Hello World !",13,0');
  writeln('.CODE ; Start of Code');
  writeln('@Start:');
  writeln(' LDA #<MSG');
  writeln(' LDY #>MSG');
  writeln(' JSR $AB1E');
  writeln('RTS');
  writeln('END');
 end;

 if (length(src)<4)or(src[length(src)-3]<>'.') then src:=src+'.A64';
 dst:=copy(src,1,length(src)-3)+'prg';

 pgm.Create;

 if Try(ECompile) then begin { try=true }

  pgm.LoadFromFile(src);
  pgm.Compile;
  pgm.SaveToFile(dst);

  Finally;
  WriteLn('Compilation done.');

 end else begin { try=false on raise }

  pgm.ErrorLine;
  WriteLn(ECompile.Message);

 end;

 pgm.Destroy;

end.