Unit A64SRC;
{ C64 Assembler (c) 1998, Paul TOTH <tothpaul@multimania.com>

 http://www.multimania.com/tothpaul

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

Interface

Uses Source,Except;

Type
 TA64SRC=Object(TSource)
  LineNumber:word;
  Line:string;
  function NextToken:string;
  procedure Comment;
  function GetBasicLine:boolean;
  function NextCodeLine:string;
 end;

Implementation

Function TA64SRC.NextToken:string;
 begin
  repeat
   SkipBlanks;
   Token:=UpCase(DropChar);
   case Token[1] of
    'A'..'Z','_': ReadAlpha;
    '0'..'9'    : ReadNumber;
   end;
   if Token=';'  then begin Token:=''; Comment; end;
  until Token<>'';
  NextToken:=Token;
 end;

Procedure TA64SRC.Comment;
 var
  l:word;
 begin
  l:=SourceLine;
  repeat DropChar Until (SourceLine>l);
 end;

Function TA64SRC.GetBasicLine:boolean;
 var
  x:byte;
 begin
  GetBasicLine:=False;
  NextToken;
  if not (Token[1] in ['0'..'9']) then exit;
  LineNumber:=0;
  for x:=1 to length(Token) do begin
   LineNumber:=10*LineNumber+ord(Token[x])-ord('0');
  end;
  SkipSpaces;
  Line:=NextLine;
  GetBasicLine:=True;
 end;

Function TA64SRC.NextCodeLine:string;
 var
  l:word;
  quote:boolean;
  c:char;
 begin
  SkipSpaces;
  Line:='';
  l:=SourceLine;
  quote:=false;
  repeat
   c:=DropChar;
   if (c in ['"','''']) then quote:=not quote;
   if (not quote) and (c=';') then begin
    NextLine;
    break;
   end;
   Line:=Line+c;
  until (SourceLine>l);
  while line[length(line)] in [#13,' '] do dec(Line[0]);
  NextCodeLine:=Line;
 end;

end.