Unit MOS6510;
{ C64 Assembler (c) 1998, Paul TOTH <tothpaul@multimania.com>

 http://www.multimania.com/tothpaul

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

Interface

{
  XXX           Impl

  XXX #$00      Immd

  XXX  $00      ZPge/Rela
  XXX  $00+X    ZPgX
  XXX  $00+Y    ZPgY

  XXX ($00+X)   IndX
  XXX ($00)+Y   IndY

  XXX  $0000    Abso
  XXX  $0000+X  AbsX
  XXX  $0000+Y  AbsY

  XXX ($0000)   Indr
}

uses
 Except,Source;

Type
 TCode=record
  Size:byte;
  Code:byte;
  case boolean of
   true :(pip1:byte);
   false:(pip2:word);
  end;

Procedure Encode(s,ss:string; Var Code:TCode);

Implementation

Type
 TOpCode=record
  Name:array[0..2] of char;
  Code:byte;
 end;

Const
 ImplCount=29;
 Impl:array[0..ImplCount-1] of TOpCode=(
  (Name:'ASL'; Code:$0A),

  (Name:'BRK'; Code:$00),

  (Name:'CLC'; Code:$18),
  (Name:'CLD'; Code:$D8),
  (Name:'CLI'; Code:$58),
  (Name:'CLV'; Code:$B8),

  (Name:'DEX'; Code:$CA),
  (Name:'DEY'; Code:$88),

  (Name:'INX'; Code:$E8),
  (Name:'INY'; Code:$C8),

  (Name:'LSR'; Code:$4A),

  (Name:'NOP'; Code:$EA),

  (Name:'PHA'; Code:$48),
  (Name:'PHP'; Code:$08),
  (Name:'PLA'; Code:$68),
  (Name:'PLP'; Code:$28),

  (Name:'ROL'; Code:$2A),
  (Name:'ROR'; Code:$6A),
  (Name:'RTI'; Code:$40),
  (Name:'RTS'; Code:$60),

  (Name:'SEC'; Code:$38),
  (Name:'SED'; Code:$F8),
  (Name:'SEI'; Code:$78),

  (Name:'TAX'; Code:$AA),
  (Name:'TAY'; Code:$A8),
  (Name:'TSX'; Code:$BA),
  (Name:'TXA'; Code:$8A),
  (Name:'TXS'; Code:$9A),
  (Name:'TYA'; Code:$98)
 );

 ImmdCount=18;
 Immd:array[0..ImmdCount-1] of TOpCode=(
  (Name:'ADC'; Code:$69),
  (Name:'ANC'; Code:$0B),
  (Name:'AND'; Code:$29),
  (Name:'ANE'; Code:$8B),
  (Name:'ARR'; Code:$6B),
  (Name:'ASR'; Code:$4B),

  (Name:'CMP'; Code:$C9),
  (Name:'CPX'; Code:$E0),
  (Name:'CPY'; Code:$C0),

  (Name:'EOR'; Code:$49),

  (Name:'LDA'; Code:$A9),
  (Name:'LDX'; Code:$A2),
  (Name:'LDY'; Code:$A0),
  (Name:'LXA'; Code:$AB),

  (Name:'NOP'; Code:$80),

  (Name:'ORA'; Code:$09),

  (Name:'SBC'; Code:$E9),
  (Name:'SBX'; Code:$CB)
 );

 RelaCount=8;
 Rela:array[0..RelaCount-1] of TOpCode=(
  (Name:'BCC'; Code:$90),
  (Name:'BCS'; Code:$B0),
  (Name:'BEQ'; Code:$F0),
  (Name:'BNE'; Code:$D0),
  (Name:'BMI'; Code:$30),
  (Name:'BPL'; Code:$10),
  (Name:'BVC'; Code:$50),
  (Name:'BVS'; Code:$70)
 );

 ZPgeCount=30;
 ZPge:array[0..ZPgeCount-1] of TOpCode=(
  (Name:'ADC'; Code:$65),
  (Name:'AND'; Code:$25),
  (Name:'ASL'; Code:$06),

  (Name:'BIT'; Code:$24),

  (Name:'CMP'; Code:$C5),
  (Name:'CPX'; Code:$E4),
  (Name:'CPY'; Code:$C4),

  (Name:'DCP'; Code:$C7),
  (Name:'DEC'; Code:$C6),

  (Name:'EOR'; Code:$45),

  (Name:'INC'; Code:$E6),
  (Name:'ISB'; Code:$E7),

  (Name:'LAX'; Code:$A7),
  (Name:'LDA'; Code:$A5),
  (Name:'LDX'; Code:$A6),
  (Name:'LDY'; Code:$A4),
  (Name:'LSR'; Code:$46),

  (Name:'NOP'; Code:$04),

  (Name:'ORA'; Code:$05),

  (Name:'RLA'; Code:$27),
  (Name:'ROL'; Code:$26),
  (Name:'ROR'; Code:$66),
  (Name:'RRA'; Code:$67),

  (Name:'SAX'; Code:$87),
  (Name:'SBC'; Code:$E5),
  (Name:'SLO'; Code:$07),
  (Name:'SRE'; Code:$47),
  (Name:'STA'; Code:$85),
  (Name:'STX'; Code:$86),
  (Name:'STY'; Code:$84)
 );

 ZPgXCount=23;
 ZPgX:array[0..ZPgXCount-1] of TOpCode=(
  (Name:'ADC'; Code:$75),
  (Name:'AND'; Code:$35),
  (Name:'ASL'; Code:$16),

  (Name:'CMP'; Code:$D5),

  (Name:'DCP'; Code:$D7),
  (Name:'DEC'; Code:$D6),

  (Name:'EOR'; Code:$55),

  (Name:'INC'; Code:$F6),
  (Name:'ISB'; Code:$F7),

  (Name:'LDA'; Code:$B5),
  (Name:'LDY'; Code:$B4),
  (Name:'LSR'; Code:$56),

  (Name:'NOP'; Code:$14),

  (Name:'ORA'; Code:$15),

  (Name:'RLA'; Code:$37),
  (Name:'ROL'; Code:$36),
  (Name:'ROR'; Code:$76),
  (Name:'RRA'; Code:$77),

  (Name:'SBC'; Code:$F5),
  (Name:'SLO'; Code:$17),
  (Name:'SRE'; Code:$57),
  (Name:'STA'; Code:$95),
  (Name:'STY'; Code:$94)
 );


 ZPgYCount=4;
 ZPgY:array[0..ZPgYCount-1] of TOpCode=(
  (Name:'LAX'; Code:$B7),
  (Name:'LDX'; Code:$B6),
  (Name:'SAX'; Code:$97),
  (Name:'STX'; Code:$96)
 );

 IndXCount=16;
 IndX:array[0..IndXCount-1] of TOpCode=(
  (Name:'ADC'; Code:$61),
  (Name:'AND'; Code:$21),

  (Name:'CMP'; Code:$C1),

  (Name:'DCP'; Code:$C3),

  (Name:'EOR'; Code:$41),

  (Name:'ISB'; Code:$E3),

  (Name:'LAX'; Code:$A3),
  (Name:'LDA'; Code:$A1),

  (Name:'ORA'; Code:$01),

  (Name:'RLA'; Code:$23),
  (Name:'RRA'; Code:$63),

  (Name:'SAX'; Code:$83),
  (Name:'SBC'; Code:$E1),
  (Name:'SLO'; Code:$03),
  (Name:'SRE'; Code:$43),
  (Name:'STA'; Code:$81)
 );

 IndYCount=16;
 IndY:array[0..IndYCount-1] of TOpCode=(
  (Name:'ADC'; Code:$71),
  (Name:'AND'; Code:$31),

  (Name:'CMP'; Code:$D1),

  (Name:'DCP'; Code:$D3),

  (Name:'EOR'; Code:$51),

  (Name:'ISB'; Code:$F3),

  (Name:'LAX'; Code:$B3),
  (Name:'LDA'; Code:$B1),

  (Name:'ORA'; Code:$11),

  (Name:'RLA'; Code:$33),
  (Name:'RRA'; Code:$73),

  (Name:'SBC'; Code:$F1),
  (Name:'SHA'; Code:$93),
  (Name:'SLO'; Code:$13),
  (Name:'SRE'; Code:$53),
  (Name:'STA'; Code:$91)
 );

 AbsoCount=32;
 Abso:array[0..AbsoCount-1] of TOpCode=(
  (Name:'AND'; Code:$2D),
  (Name:'ASL'; Code:$0E),
  (Name:'ADC'; Code:$6D),

  (Name:'BIT'; Code:$2C),

  (Name:'CMP'; Code:$CD),
  (Name:'CPX'; Code:$EC),
  (Name:'CPY'; Code:$CC),

  (Name:'DCP'; Code:$CF),
  (Name:'DEC'; Code:$CE),

  (Name:'EOR'; Code:$4D),

  (Name:'INC'; Code:$EE),
  (Name:'ISB'; Code:$EF),

  (Name:'JMP'; Code:$4C),
  (Name:'JSR'; Code:$20),

  (Name:'LAX'; Code:$AF),
  (Name:'LDA'; Code:$AD),
  (Name:'LDX'; Code:$AE),
  (Name:'LDY'; Code:$AC),
  (Name:'LSR'; Code:$4E),

  (Name:'NOP'; Code:$0C),

  (Name:'ORA'; Code:$0D),

  (Name:'RLA'; Code:$2F),
  (Name:'ROL'; Code:$2E),
  (Name:'ROR'; Code:$6E),
  (Name:'RRA'; Code:$6F),

  (Name:'SAX'; Code:$8F),
  (Name:'SBC'; Code:$ED),
  (Name:'SLO'; Code:$0F),
  (Name:'SRE'; Code:$4F),
  (Name:'STA'; Code:$8D),
  (Name:'STX'; Code:$8E),
  (Name:'STY'; Code:$8C)
 );

 AbsXCount=22;
 AbsX:array[0..AbsXCount-1] of TOpCode=(
  (Name:'ADC'; Code:$7D),
  (Name:'AND'; Code:$3D),
  (Name:'ASL'; Code:$1E),

  (Name:'CMP'; Code:$DD),

  (Name:'DCP'; Code:$DF),
  (Name:'DEC'; Code:$DE),

  (Name:'EOR'; Code:$5D),

  (Name:'INC'; Code:$FE),
  (Name:'ISB'; Code:$FF),

  (Name:'ORA'; Code:$1D),

  (Name:'LDA'; Code:$BD),
  (Name:'LDY'; Code:$BC),
  (Name:'LSR'; Code:$5E),

  (Name:'RLA'; Code:$3F),
  (Name:'ROL'; Code:$3E),
  (Name:'ROR'; Code:$7E),
  (Name:'RRA'; Code:$7F),

  (Name:'SBC'; Code:$FD),
  (Name:'SHY'; Code:$9C),
  (Name:'SLO'; Code:$1F),
  (Name:'SRE'; Code:$5F),
  (Name:'STA'; Code:$9D)
 );

 AbsYCount=19;
 AbsY:array[0..AbsYCount-1] of TOpCode=(
  (Name:'ADC'; Code:$79),
  (Name:'AND'; Code:$39),

  (Name:'CMP'; Code:$D9),

  (Name:'DCP'; Code:$DB),

  (Name:'EOR'; Code:$59),

  (Name:'ISB'; Code:$FB),

  (Name:'LAS'; Code:$BB),
  (Name:'LAX'; Code:$BF),
  (Name:'LDA'; Code:$B9),
  (Name:'LDX'; Code:$BE),

  (Name:'ORA'; Code:$19),

  (Name:'RLA'; Code:$3B),
  (Name:'RRA'; Code:$7B),

  (Name:'SBC'; Code:$F9),
  (Name:'SHA'; Code:$9F),
  (Name:'SHS'; Code:$9B),
  (Name:'SHX'; Code:$9E),
  (Name:'SLO'; Code:$1B),
  (Name:'SRE'; Code:$5B)
 );

 IndrCount=1;
 Indr:array[0..IndrCount-1] of TOpCode=(
  (Name:'JMP'; Code:$6C)
 );

procedure trim(var s:string);
 var
  b,e:byte;
 begin
  b:=1;
  e:=length(s);
  while (b<=e)and(s[b]=' ') do inc(b);
  while (e>b)and(s[e]=' ') do dec(e);
  s:=copy(s,b,e-b+1);
 end;

procedure split(var s:string; sep:char;var ss:string);
 var
  p:byte;
 begin
  p:=pos(sep,s);
  if p=0 then
   ss:=''
  else begin
   ss:=copy(s,p+1,length(s));
   s[0]:=chr(p-1);
  end;
 end;

Function FindCode(OpCode:string; OpCodes:array of TOpCode):word;
 var
  op:byte;
 begin
  for op:=Low(OpCodes) to High(OpCodes) do begin
   if OpCodes[op].Name=OpCode then begin
    FindCode:=OpCodes[op].Code;
    exit;
   end;
  end;
  raise('Invalide combinaison of opcode');
 end;

Function Immed(s:string):byte;
 var
  x:byte;
  result:integer;
  base:byte;
  neg:boolean;
  num:byte;
 begin
  x:=2; { after # }
  base:=10;
  neg:=false;
  if s[x]='-' then begin
   inc(x);
   neg:=true;
  end;
  if s[x]='$' then begin
   inc(x);
   base:=16;
  end;
  result:=0;
  while x<=length(s) do begin
   num:=pos(s[x],digits);
   if num>base then raise('invalide number');
   result:=base*result+num-1;
   inc(x);
  end;
  if result>255 then raise('invalide byte');
  if neg then result:=-result;
  Immed:=result and 255;
 end;

Function Addr(s:string):word;
 var
  x:byte;
  result:word;
  base:byte;
  num:byte;
 begin
  x:=1;
  base:=10;
  if s[x]='$' then begin
   inc(x);
   base:=16;
  end;
  result:=0;
  while x<=length(s) do begin
   num:=pos(s[x],digits);
   if num>base then raise('invalide number');
   result:=base*result+num-1;
   inc(x);
  end;
  Addr:=Result;
 end;

procedure EnCode(s,ss:string; Var Code:TCode);
 var
  sss:string;
  e:TException;
 begin
  trim(ss);

  if ss='' then begin
   { Impl }
   Code.Size:=1;
   Code.Code:=FindCode(s,Impl);
   exit;
  end;

  if (ss[1]='''')or(ss[1]='"') then begin
   { Immd char }
   if (length(ss)<>3)or(ss[3]<>ss[1]) then raise('Invalide char');
   Code.Size:=2;
   Code.Code:=FindCode(s,Immd);
   Code.Pip1:=Ord(ss[2]);
   exit;
  end;

  if ss[1]='#' then begin
  { Immd value }
   Code.Size:=2;
   Code.Code:=FindCode(s,Immd);
   if ss[2]='<' then Code.Pip1:=0 else
   if ss[2]='>' then Code.Pip1:=1 else
   Code.Pip1:=Immed(ss);
   exit;
  end;

  if ss[1]='@' then begin { Label: Abso, Rela }
   if try(e) then begin
    Code.Code:=FindCode(s,Rela);
    finally;
    Code.Size:=2;
   end else begin
    Code.Code:=FindCode(s,Abso);
    Code.Size:=3;
   end;
   exit;
  end;

  if ss[1]='(' then begin { IndX/IndY/Indr }

   delete(s,1,1);

   if pos('+',ss)=0 then begin { Indr }
    if ss[length(ss)]<>')' then raise('Invalide Indirect');
    dec(ss[0]);
    Code.Size:=3;
    Code.Code:=FindCode(s,Indr);
    Code.Pip2:=Addr(ss);
    exit;
   end;

   split(ss,')',sss);
   if sss='' then begin { IndY }
    split(ss,'+',sss);
    if sss<>'X' then raise('invalide Indirect X mode');
    Code.Size:=2;
    Code.Code:=FindCode(s,IndX);
    Code.Pip1:=Immed(ss);
    exit;
   end;

   if sss<>'+Y' then raise('invalide Indirect Y mode');
   Code.Size:=2;
   Code.Code:=FindCode(s,IndY);
   Code.Pip1:=Immed(ss);
   exit;

  end;

  split(ss,'+',sss); { Zpge,Abso }
  if sss='' then begin
   Code.Pip2:=Addr(ss);
   if try(e) then begin
    if Code.Pip2>255 then raise(nil);
    Code.Code:=FindCode(s,ZPge);
    finally;
    Code.Size:=2;
   end else begin
    Code.Code:=FindCode(s,Abso);
    Code.Size:=3;
   end;
   exit;
  end;

  if sss='X' then begin { ZPgX,AbsX }
   Code.Pip2:=Addr(ss);
   if try(e) then begin
    if Code.Pip2>255 then raise(nil);
    Code.Code:=FindCode(s,ZPgX);
    finally;
    Code.Size:=2;
   end else begin
    Code.Code:=FindCode(s,AbsX);
    Code.Size:=3;
   end;
   exit;
  end;

  if sss='Y' then begin { ZPgY,AbsY }
   Code.Pip2:=Addr(ss);
   if try(e) then begin
    if Code.Pip2>255 then raise(nil);
    Code.Code:=FindCode(s,ZPgY);
    finally;
    Code.Size:=2;
   end else begin
    Code.Code:=FindCode(s,AbsY);
    Code.Size:=3;
   end;
   exit;
  end;

  raise('Invalide code');
 end;

end.